/* GCC */
#include <set>
#include <stack>
#include <vector>
#include <math.h>
#include <iostream>
#include <algorithm>

#define pb push_back
#define mp make_pair
#define F first
#define S second
#define Ri(a) scanf("%d", &a)
#define Ri2(a,b) scanf("%d%d", &a, &b)
#define Wi(a) printf("%d ", a)
#define Wi2(a,b) printf("%d %d ", a, b)
#define Wie(a) printf("%d\n", a)
#define Wie2(a,b) printf("%d %d\n", a, b)
#define FOR(i,a,b) for( int i = (a), _n_ = (b); i <= _n_; i++ )
#define FORD(i,a,b) for( int i = (a), _n_ = (b); i >= _n_; i-- )
#define forn(i,n) FOR(i,0,(n)-1)
#define pii pair < int, int >

using namespace std;

int n;
vector < pii > p;
vector < char > pos;

int turn( int x1, int y1, int x2, int y2, int x3, int y3 ) {
    return ( x2 - x1 ) * ( y3 - y1 ) - ( y2 - y1 ) * ( x3 - x1 );
}

bool comp( pii a, pii b ) {
     return ( a.F < b.F ) || ( (a.F == b.F) && (a.S < b.S) );
}

stack < pii > st;
int find( vector <char>& pos ) {
    pii b, e;
    forn( i, pos.size() )
          if( pos[i] == 1 ) {
              b = p[i];
              break;
          }
    FORD( i, pos.size() - 1, 0 )
          if( pos[i] == 1 ) {
              e = p[i];
              break;
          }
    
    while( !st.empty() ) st.pop();
    pii p1, p2;
    forn( i, pos.size() ) {
          if( pos[i] == 1 && turn( b.F, b.S, e.F, e.S, p[i].F, p[i].S ) >= 0 ) {
              while( st.size() >= 2 ) {
                     p2 = st.top();
                     st.pop();
                     p1 = st.top();
                     st.pop();
                     if( turn( p1.F, p1.S, p2.F, p2.S, p[i].F, p[i].S ) > 0 ) {
                         st.push( p1 );
                     } else {
                            st.push( p1 );
                            st.push( p2 );
                            break;
                     }
              }
              st.push( p[i] );
          }
    }
    int res = st.size() - 1;
    
    while( !st.empty() ) st.pop();
    st.push( b );
    forn( i, pos.size() ) {
          if( pos[i] == 1 && turn( b.F, b.S, e.F, e.S, p[i].F, p[i].S ) < 0) {
              while( st.size() >= 2 ) {
                     p2 = st.top();
                     st.pop();
                     p1 = st.top();
                     st.pop();
                     if( turn( p1.F, p1.S, p2.F, p2.S, p[i].F, p[i].S ) < 0 ) {
                         st.push( p1 );
                     } else {
                            st.push( p1 );
                            st.push( p2 );
                            break;
                     }
              }
              st.push( p[i] );
          }
    }
    return res + st.size();
}

int main() {
    freopen("fortress.in", "r", stdin);
    freopen("fortress.out", "w", stdout);
    
    Ri( n );
    p.reserve( n );
    forn( i, n ) Ri2( p[i].F, p[i].S );
    forn( i, n ) cout << p[i].F << " " << p[i].S << endl;
    sort( p.begin(), p.end(), comp );
    swap( p[0], p[1] );
    forn( i, n ) cout << p[i].F << " " << p[i].S << endl;
    
    pos.assign( n, 1 );
    Wie( find( pos ) );
    
    return 0;
}
