/* GCC */

#include <fstream>
#include <algorithm>
#include <vector>
#include <bitset>

using namespace std;

struct point
{
    int x, y;       
};

int N;
point *p;
bool ool[100][100][100]; //On one line

bool f(bitset<100> used, int n, int pre, int prepre)
{
     if(n == -1)
        return true;
        
     bitset<100> tmp;
     for(int i = 0; i <= N-n; i++)
     {
          if(used[i])
               continue;
          
          if(pre != -1 && prepre != -1)
               if(ool[prepre][pre][i])       
                   continue;
          
          tmp = used;
          tmp[i] = 1;
          if(f(tmp, n-1, i, pre))
              return true;   
     }
     return false;
}

inline float abs(float a)
{
    return a >= false ? a : -1*a; 
}

int main()
{
    ifstream fin("fortress.in");
    fin>>N;
    p = new point[N];
    for(int i = 0; i < N; i++)
        fin>>p[i].x>>p[i].y;
    fin.close();
    
    ofstream fout("fortress.out");
    for(int i = 0; i < N; i++)
        for(int j = i+1; j < N; j++)
            for(int k = j+1; k < N; k++)
            {
                float tmp1 = abs((float)(p[i].y - p[j].y)/(p[i].x - p[j].x)), 
                      tmp2 = abs((float)(p[i].y - p[k].y)/(p[i].x - p[k].x));
                       
                ool[i][j][k] = ool[i][k][j] = ool[j][i][k] = 
                ool[j][k][i] = ool[k][i][j] = ool[k][j][i] = (tmp1 == tmp2);
            }
    
    for(int i = N; i > 2; i--)
    {
            if(f(bitset<100>(), i, -1, -1))
            {
                 fout<<i<<endl;
                 fout.close();
                 return 0;                    
            }
    }
    
    fout<<"0\n";
    fout.close();
    return 0;  
}
