/* GCC */

#include <fstream>
#include <bitset>
#include <vector>

using namespace std;

int N, M;
int *H;
vector< bitset<20> > Y[41];

inline bool Invalid()
{
     for(int i = 0; i < N-1; i++)
         if(H[i] < H[i+1])
             return true;
     return false;
}

inline bool IsVkl(bitset<20> bigger, bitset<20> smaller)
{
     for(int i = 0; i < N; i++)
         if(smaller[i] == 1 && bigger[i] == 0)
             return false;
     return true;
}

void f(bitset<20> pos, unsigned v, int start)
{
    Y[v].push_back(pos);
    
    if(start == M)
        return;
    
    for(unsigned i = start; i < M; i++)
    {
         unsigned long long tmp_v = v + (1 << i);
         bitset<20> tmp_pos = pos;
         tmp_pos[i] = 1;
         f(tmp_pos, tmp_v % 41, i+1);
    }
}

unsigned long long res = 0;

void g(vector< bitset<20> > prev, int n)
{
     if(n == N)
     {
         res++;
         return;
     }
     
     vector< bitset<20> > tmp;
     
     for(int i = 0; i < Y[H[n]].size(); i++)
     {
             if(/*prev.back() != Y[H[n]][i] &&*/ IsVkl(prev.back(), Y[H[n]][i]))
             {
                 tmp = prev;
                 tmp.push_back(Y[H[n]][i]);
                 g(tmp, n+1);                      
             }
     }
}

int main()
{
    ifstream fin("nested.in");
    
    fin>>N>>M;
    H = new int[N];
    for(int i = 0; i < N; i++)
        fin>>H[i];
        
    ofstream fout("nested.out");
    
    if(N > 1 && Invalid())
    {
        fout<<"0\n";
        fout.close();
        return 0;
    }
    
    bitset<20> tmp;
    f(tmp, 0, 0);
    tmp.flip();
    g(vector< bitset<20> > (1, tmp), 0);
    
    fout<<res<<endl;
    fout.close();
    
    return 0;
}
